/*
 * GPT12.c
 *
 *  Created on: 2021. 3. 9.
 *      Author: User
 */

#include "GPT12.h"

#define INTERRUPT_PRIORITY_GPT12 20

IfxGpt12_IncrEnc GPT12Handler;
IfxStdIf_Pos StdIfPosHandler;

IFX_INTERRUPT(GPT12_ISR, 0, INTERRUPT_PRIORITY_GPT12);

void GPT12_ISR(void) {

	IfxCpu_enableInterrupts();
	IfxGpt12_IncrEnc_onZeroIrq(&GPT12Handler);
}

void GPT12_Init(void) {

	IfxGpt12_IncrEnc_Config config;

	IfxGpt12_IncrEnc_initConfig(&config, &MODULE_GPT120);
	config.base.reversed = 1;
	config.base.resolution = 1024;
	config.base.resolutionFactor = IfxStdIf_Pos_ResolutionFactor_fourFold;

    config.base.maxSpeed                  = 5000.0 / 60.0 * (2 * IFX_PI); // 20000 rpm
    config.base.speedFilerCutOffFrequency = config.base.maxSpeed / 2 * IFX_PI * 10;

	config.zeroIsrPriority = INTERRUPT_PRIORITY_GPT12;
	config.pinA = &IfxGpt120_T3INA_P02_6_IN;
	config.pinB = &IfxGpt120_T3EUDA_P02_7_IN;
	config.pinZ = &IfxGpt120_T4INA_P02_8_IN;

	IfxGpt12_enableModule(&MODULE_GPT120);
	IfxGpt12_IncrEnc_init(&GPT12Handler, &config);
	IfxGpt12_IncrEnc_stdIfPosInit(&StdIfPosHandler, &GPT12Handler);
}
