/*
 * STM.c
 *
 *  Created on: 2021. 3. 9.
 *      Author: User
 */

#include "STM.h"

#define ISR_PRIORITY_STM	65

#define LED                     &MODULE_P13,0

IfxStm_CompareConfig STMHandler;
uint32 Tick;

IFX_INTERRUPT(STM_ISR, 0, ISR_PRIORITY_STM);

uint32 SystemTimeTick;

void STM_ISR(void) {

	IfxCpu_enableInterrupts();
    IfxStm_increaseCompare(&MODULE_STM0, STMHandler.comparator, Tick);

    SystemTimeTick++;
}

void STM_init(void) {

	Tick = IfxStm_getTicksFromMilliseconds(BSP_DEFAULT_TIMER, 1);

    IfxStm_initCompareConfig(&STMHandler);

    STMHandler.triggerPriority = ISR_PRIORITY_STM;
    STMHandler.typeOfService = IfxSrc_Tos_cpu0;
    STMHandler.ticks = Tick;

    IfxPort_setPinMode(LED, IfxPort_Mode_outputPushPullGeneral);    /* Initialize LED port pin                      */
    IfxPort_setPinState(LED, IfxPort_State_high);                   /* Turn off LED (LED is low-level active)       */

    IfxStm_initCompare(&MODULE_STM0, &STMHandler);
}

uint32 STM_getTick(void) {

	return SystemTimeTick;
}

uint32 STM_getElapsedTick(uint32 tick) {

	return (STM_getTick() - tick);
}

void STM_delay(uint32 ms) {

	uint32 now = STM_getTick();

	while(STM_getElapsedTick(now) < ms) {}
}
