/*
 * VADC.h
 *
 *  Created on: 2021. 3. 9.
 *      Author: User
 */

#ifndef HAL_VADC_VADC_H_
#define HAL_VADC_VADC_H_

#include "IfxVadc_Adc.h"

#define INTERRUPT_VADC_RESULT_GROUP0 100
#define NUMBER_OF_USE_GROUP 4

#define 	APPVADC_CFG_VMOTOR_MIN	(2.3)
#define 	APPVADC_CFG_VMOTOR_MAX	(2.7)
#define 	APPVADC_CFG_VMOTOR_GAIN	0.00122070
#define 	APPVADC_CFG_VMOTOR_OFFSET	0.0
#define		APPVADC_CFG_VMOTOR_OFFSET_NOM  (2048)
#define		CFG_AN_I_CALIBRATION_COUNT 	(512)

#define 	APPVADC_CFG_IMOTOR_MIN	(-70.0)
#define 	APPVADC_CFG_IMOTOR_MAX	(70.0)

#define 	APPVADC_CFG_IMOTOR_GAIN	(-(5.0/(4096 * 32 * 0.01)))
#define 	APPVADC_CFG_IMOTOR_OFFSET	(2.5 / (32 * 0.01))

typedef enum {
	AppVadc_Ch_I_U,
	AppVadc_Ch_V_Vro,
	AppVadc_Ch_I_V, AppVadc_ChannelCount
} AppVadc_Channels;

typedef enum
{
	AppVadc_LimitsStatus_Ok,
	AppVadc_LimitsStatus_Min,
	AppVadc_LimitsStatus_Max,
	AppVadc_LimitsStatus_OutOfRange
}AppVadc_LimitsStatus;

typedef void (*AppVadc_Limits_onOutOfRange)(void *object, AppVadc_LimitsStatus status, uint32 info);

typedef struct {
    float32 min;
    float32 max;
    AppVadc_LimitsStatus status;
    AppVadc_Limits_onOutOfRange onOutOfRange;
    void* object;
    uint32 info;
} AppVadc_Limits_1_float32;

typedef struct {
	IfxVadc_RequestSource requestSource;
	uint16 priority;// for request source queued [range 1..8] 1 means first in the queue 8 last in queue
	boolean refill;					// for request source queued refill in queue
	boolean trigger;// for request source queued seperate trigger for channel
} AppVadc_Conversion_cfg;

typedef struct {
	IfxVadc_GroupId groupId;
	IfxVadc_Adc_ChannelConfig hwChannel;
	AppVadc_Conversion_cfg coversionSetup;
	AppVadc_Limits_1_float32 limits;
	float32 gain;
	float32 offset;
} AppVadc_AnalogInput_cfg;

typedef struct {
	IfxVadc_Adc_Channel input;
	uint32 rawvalue;
	AppVadc_Limits_1_float32 limits;
	float32 gain;
	float32 offset;
	float32 value;
} AppVadc_AnalogInput_1;

void AppVadc_init(void);
float32 AppVadc_updateAnalogInput(AppVadc_AnalogInput_1 *input);
AppVadc_AnalogInput_1* AppVadc_getCurrentPhaseU_object(void);
AppVadc_AnalogInput_1* AppVadc_getCurrentPhaseV_object(void);
AppVadc_AnalogInput_1* AppVadc_getCurrentOffset_object(void);


IFX_INLINE void AppVadc_setOutOfRangefunction(AppVadc_AnalogInput_1 *input, AppVadc_Limits_onOutOfRange onOutOfRange, void *object)
{
	input->limits.onOutOfRange = onOutOfRange;
	input->limits.object = object;
}

#endif /* HAL_VADC_VADC_H_ */
