/*
 * Encoder.c
 *
 *  Created on: 2021. 3. 10.
 *      Author: User
 */


#include "Encoder.h"
#include "GPT12.h"
#include "Ifx_LowPassPt1F32.h"

Ifx_LowPassPt1F32 LPFHandler;

void ENC_init(void) {

	Ifx_LowPassPt1F32_Config lpfConfig;

	lpfConfig.gain = 1.0;
	lpfConfig.samplingTime = 0.001;
	lpfConfig.cutOffFrequency = 40000.0;

	Ifx_LowPassPt1F32_init(&LPFHandler, &lpfConfig);
	GPT12_Init();
}

sint32 ENC_getPosition(void) {

	IfxStdIf_Pos_update(&StdIfPosHandler);
	return GPT12Handler.rawPosition;
}

float32 ENC_getSpeed(void) {

	float32 result;

	IfxStdIf_Pos_update(&StdIfPosHandler);

	result = Ifx_LowPassPt1F32_do(&LPFHandler, GPT12Handler.speed);
	return result;
}
