/*
 * PI.h
 *
 *  Created on: 2021. 3. 10.
 *      Author: User
 */

#ifndef MOTOR_MATH_PI_H_
#define MOTOR_MATH_PI_H_

#include "Ifx_Types.h"

typedef struct {
	float32 a0;
	float32 a1;
	float32 uk;
	float32 ik;
	float32 min;
	float32 max;
	uint8 hitLimits;
} TPic;

void PIC_Init(TPic * pic);
void PIC_Reset(TPic * pic);

void PIC_SetKpKi_float32(TPic * pic, float32 kp, float32 ki, float32 sampleTime, sint32 shiftCoef, sint8 shiftResult);
void PIC_GetKpKi_float32(TPic * pic, float32 *kp, float32 *ki, float32 sampleTime, sint32 shiftCoef);
void PIC_SetKpKi(TPic * pic, float32 kp, float32 ki, float32 sampleTime);
void PIC_GetKpKi(TPic * pic, float32 *kp, float32 *ki, float32 sampleTime);
void PIC_SetLimit(TPic * pic, float32 min, float32 max);
void PIC_GetLimit(TPic * pic, float32 *min, float32 *max);
float32 PIC_Do(TPic * pic, float32 input);

boolean PIC_IsLimitsHit(TPic * pic);
void PIC_ResetLimitsHit(TPic * pic);

#endif /* MOTOR_MATH_PI_H_ */
