/*
 * Tables.h
 *
 *  Created on: 2021. 3. 10.
 *      Author: User
 */

#ifndef MOTOR_MATH_TABLES_H_
#define MOTOR_MATH_TABLES_H_

#include "Ifx_Types.h"
#include "IfxCpu_Intrinsics.h"

#define COSSIN_TABLE_RESOLUTION (10)
#define COSSIN_TABLE_SIZE       (1<<COSSIN_TABLE_RESOLUTION)
#define INDEX_PI   (COSSIN_TABLE_SIZE / 2)

#define ARCTAN_TABLE_LOW_SIZE    (512)
#define ARCTAN_TABLE_HIGH_SIZE   (512)

#define ARCTAN_LIMIT_LOW         (4)
#define ARCTAN_LIMIT_HIGH        (64)

extern const float32 sinCosTable[1280];
extern const float32* cosTable;
extern float32 sinCosVector[14];

IFX_INLINE float32 TBL_sinus(sint32 index) {

	index &= COSSIN_TABLE_SIZE - 1;
	return sinCosTable[index];
}

IFX_INLINE float32 TBL_cosinus(sint16 index) {

	index &= (COSSIN_TABLE_SIZE - 1);
	return cosTable[index];
}

IFX_INLINE cfloat32 TBL_cosinusSinus(sint32 index) {

	cfloat32 result;

	index &= COSSIN_TABLE_SIZE - 1;
	result.imag = sinCosTable[index];
	result.real = cosTable[index];

	return result;
}

void TBL_init(void);
sint16 TBL_getArctan(float32 x, float32 y);

#endif /* MOTOR_MATH_TABLES_H_ */
