/*
 * Transformation.c
 *
 *  Created on: 2021. 3. 10.
 *      Author: User
 */

#include "Transformation.h"

cfloat32 TRSF_clark(T3Phase* currents) {

	cfloat32 result;
	result.real = currents->u;
	result.imag = IFX_ONE_OVER_SQRT_THREE * (currents->v - currents->w);

	return result;
}

cfloat32 TRSF_park(cfloat32* mab, cfloat32* cosSin) {

	cfloat32 result;

	result.real = (mab->real * cosSin->real) + (mab->imag * cosSin->imag);
	result.imag = (mab->imag * cosSin->real) - (mab->real * cosSin->imag);

	return result;
}

cfloat32 TRSF_parkReverse(cfloat32 *mdq, cfloat32 *cosSin) {

	cfloat32 result;

	result.real = (mdq->real * cosSin->real) - (mdq->imag * cosSin->imag);
	result.imag = (mdq->real * cosSin->imag) + (mdq->imag * cosSin->real);

	return result;
}
